//
#include "StdAfx.h"

#ifdef USE_NEWDELETE

void* __cdecl operator new[](size_t nSize, int nType, LPCSTR lpszFileName, int nLine)
{
	return operator new(nSize, nType, lpszFileName, nLine);
}


void* __cdecl operator new(size_t nSize, int nType, LPCSTR lpszFileName, int nLine)
{
	void* m = operator new(nSize);
	if (m == 0) {
		char buf[1024];
		wsprintfA(buf, "%s (%d): not enough memory.\n", lpszFileName, nLine);
		::OutputDebugStringA(buf);
	}
	return m;
}


void* __cdecl operator new[](size_t l)
{
	return operator new(l);
}


void* __cdecl operator new(size_t l)
{
	//l += 16;		//TCYLāAjɑΏ...
	void* m = malloc(l);
	if (m)
		memset(m, 0x00, l);
	return m;
}

#if 0
void __cdecl operator delete[](void* p, int nType, LPCSTR /* lpszFileName */, int /* nLine */)
{
	operator delete(p);
}


void __cdecl operator delete(void* p, int nType, LPCSTR /* lpszFileName */, int /* nLine */)
{
	operator delete(p);
}
#endif


void __cdecl operator delete[](void* p)
{
	operator delete(p);
}


void __cdecl operator delete(void* p)
{
	if (p)
		free(p);
}


#endif
