// PageExit.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageExit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageExit vpeB y[W

IMPLEMENT_DYNCREATE(CPageExit, CPropertyPage)

CPageExit::CPageExit()
	: CPropertyPage(CPageExit::IDD)
{
	//{{AFX_DATA_INIT(CPageExit)
	m_UseTempFilter = FALSE;
	m_TempFilter	= _T("");
	m_TempLimit 	= 0;
	m_DelHistory	= FALSE;
	m_DelCookie 	= FALSE;
	m_DelTemporary	= FALSE;
	//}}AFX_DATA_INIT
}

CPageExit::~CPageExit()
{
}

void CPageExit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageExit)
	DDX_Check(pDX, IDC_CHECK4, m_UseTempFilter);
	DDX_Text(pDX, IDC_EDIT1, m_TempFilter);
	DDX_Text(pDX, IDC_EDIT2, m_TempLimit);
	DDV_MinMaxInt(pDX, m_TempLimit, 0, 100000);
	DDX_Check(pDX, IDC_CHECK1, m_DelHistory);
	DDX_Check(pDX, IDC_CHECK3, m_DelCookie);
	DDX_Check(pDX, IDC_CHECK2, m_DelTemporary);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageExit, CPropertyPage)
	//{{AFX_MSG_MAP(CPageExit)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageExit bZ[W nh

BOOL CPageExit::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// I
	m_DelTemporary	= g_Options.bDeleteTemporary;
	m_DelCookie 	= g_Options.bDeleteCookie;
	m_DelHistory	= g_Options.bDeleteHistory;
	// ꎞt@CtB^
	m_TempLimit 	=AfxGetApp()->GetProfileInt( _T("Exit") 		,  _T("TemporaryLimit") 	 , 3);
	m_UseTempFilter =AfxGetApp()->GetProfileInt( _T("Exit") 		,  _T("UseTempFilter")	 , FALSE);
	m_TempFilter	=AfxGetApp()->GetProfileString( _T("Exit")	,  _T("TemporaryFilter")	, _T("*.gif;*.png;*.jpg;*.html;*.htm;*.jpeg;*.js;*.css;*.swf;*/") );

	if (!m_UseTempFilter)
		OnCheck4();

	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageExit::OnOK()
{
	// I
	g_Options.bDeleteTemporary	=m_DelTemporary;
	g_Options.bDeleteCookie 	=m_DelCookie;
	g_Options.bDeleteHistory	=m_DelHistory;
	// ꎞt@CtB^
	AfxGetApp()->WriteProfileInt( _T("Exit")		,  _T("TemporaryLimit") 	 , m_TempLimit);
	AfxGetApp()->WriteProfileInt( _T("Exit")		,  _T("UseTempFilter")	 , m_UseTempFilter);
	AfxGetApp()->WriteProfileString( _T("Exit") 	,  _T("TemporaryFilter")	 , m_TempFilter);

	CPropertyPage::OnOK();
}

void CPageExit::OnCheck4()
{
	BOOL bCheck = ((CButton*)GetDlgItem(IDC_CHECK4))->GetCheck();

	GetDlgItem(IDC_EDIT1)->EnableWindow(bCheck);
	GetDlgItem(IDC_EDIT2)->EnableWindow(bCheck);
}
