// PageToolbar.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageToolbar.h"
#include "PageToolbarEdit.h"
#include "..\patriotGlobal2.h"
#include "..\burapi.h"
#include <vector>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageToolbar vpeB y[W

IMPLEMENT_DYNCREATE(CPageToolbar, CPropertyPage)

CPageToolbar::CPageToolbar()
	: CPropertyPage(CPageToolbar::IDD)
	, m_hFrameWnd(0)
	, m_pImageList(0)
	, arrTool()
	, m_Index(0)
	, m_List2()
	, m_List1()
{
	//{{AFX_DATA_INIT(CPageToolbar)
	m_BigIcon  = FALSE;
	m_ShowText = FALSE;
	//}}AFX_DATA_INIT
}

CPageToolbar::~CPageToolbar()
{
}

void CPageToolbar::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageToolbar)
	DDX_Control(pDX, IDC_LIST2, m_List2);
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Check(pDX, IDC_CHECK2, m_BigIcon);
	DDX_Check(pDX, IDC_CHECK1, m_ShowText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageToolbar, CPropertyPage)
	//{{AFX_MSG_MAP(CPageToolbar)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageToolbar bZ[W nh

typedef struct _ButtonSetting{
	UINT	nID;
	CString strLabel;
	int 	nBitmap;
} ButtonSetting;

int CPageToolbar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CPropertyPage::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

BOOL CPageToolbar::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// Inĩ[h
	m_ShowText	=AfxGetApp()->GetProfileInt( _T("Toolbar") ,  _T("ShowText")	 , FALSE);
	m_BigIcon	=AfxGetApp()->GetProfileInt( _T("Toolbar") ,  _T("BigIcon") 	 , FALSE);
	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageToolbar::LoadToolbar()
{
	TCHAR pszBuffer[MAX_PATH];

	::SendMessage( m_hFrameWnd , BURAPI_GET_SPECIAL_FOLDER , BURA_SPFOLDER_RESOURCE, reinterpret_cast<LPARAM>(pszBuffer) );
	CString strResPath = pszBuffer;

	::SendMessage( m_hFrameWnd , BURAPI_GET_SPECIAL_FOLDER , BURA_SPFOLDER_OPTION, reinterpret_cast<LPARAM>(pszBuffer) );
	CString strOptionPath = pszBuffer;

	CListCtrl* pList = (CListCtrl*)GetDlgItem(IDC_LIST1);
	CRect rect;
	pList->GetClientRect(rect);
	if (pList->GetHeaderCtrl()->GetItemCount() == 0) {
		pList->InsertColumn(0, _T("ACe"), LVCFMT_LEFT, rect.right - 20);
	}
	pList->SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// Ƀ[h
	pList->SetImageList(m_pImageList, LVSIL_SMALL);
	pList->DeleteAllItems();

	// `t@Cǂݍ
	std::vector<ButtonSetting> arrButtonDef;
	//+++ CStdioFile fileDefine( strResPath + _T("\\toolbar.dat"), CFile::modeRead);
	CReadTextFile fileDefine( strResPath + _T("\\toolbar.dat"), CFile::modeRead);
	CString str;

	while ( fileDefine.ReadString( str ) ) {
		ButtonSetting button;
		// CmdID
		CString strCmd;
		SplitStr( str , _T(',') , strCmd , str );
		button.nID = _ttoi( strCmd );
		// x
		SplitStr( str , _T(',') , button.strLabel , str );
		// Bitmap
		button.nBitmap = _ttoi( str );

		arrButtonDef.push_back( button );
	}
	// Zp[^
	ButtonSetting buttonSeparator;
	buttonSeparator.strLabel	= _T("------------");
	buttonSeparator.nBitmap 	= -1;
	buttonSeparator.nID 		= -1;

	arrButtonDef.push_back( buttonSeparator );

	// {^
	int nIndex = 0;
	for ( std::vector<ButtonSetting>::iterator i = arrButtonDef.begin() ; i != arrButtonDef.end() ; i++ ) {
		ButtonSetting* pButton = &(*i);

		pList->InsertItem( nIndex, pButton->strLabel , pButton->nBitmap );
		pList->SetItemData( nIndex, pButton->nID );
		nIndex++;
	}

	// EɃ[h
	CListCtrl* pList2 = (CListCtrl*)GetDlgItem(IDC_LIST2);
	pList2->GetClientRect(rect);
	if (pList2->GetHeaderCtrl()->GetItemCount() == 0) {
		pList2->InsertColumn(0, _T("ACe"), LVCFMT_LEFT, rect.right - 20);
	}
	pList2->SetExtendedStyle(LVS_EX_FULLROWSELECT);

	pList2->SetImageList(m_pImageList , LVSIL_SMALL);
	pList2->DeleteAllItems();

	//+++ CStdioFile fin( strOptionPath + _T("\\toolbar.dat"), CFile::modeRead );
	CReadTextFile fin( strOptionPath + _T("\\toolbar.dat"), CFile::modeRead );
	while ( fin.ReadString(str) ) {
		DWORD dwID = _ttoi( str );

		for ( std::vector<ButtonSetting>::iterator i = arrButtonDef.begin() ; i != arrButtonDef.end() ; i++ ) {
			ButtonSetting* pButton = &(*i);

			if ( pButton->nID == dwID ) {
				m_List2.InsertItem( m_List2.GetItemCount() , pButton->strLabel , pButton->nBitmap );
				m_List2.SetItemData( m_List2.GetItemCount()-1 , dwID );
			}
		}
	}
	fin.Close();
}

void CPageToolbar::OnOK()
{ // ݒۑ
	// Ini̕ۑ
	AfxGetApp()->WriteProfileInt( _T("Toolbar") ,  _T("ShowText")	 , m_ShowText);
	AfxGetApp()->WriteProfileInt( _T("Toolbar") ,  _T("BigIcon")	 , m_BigIcon);

	// ݒt@C̃pX擾
	TCHAR pszBuffer[MAX_PATH];
	::SendMessage( m_hFrameWnd , BURAPI_GET_SPECIAL_FOLDER , BURA_SPFOLDER_OPTION, reinterpret_cast<LPARAM>(pszBuffer) );
	CString strOptionPath = pszBuffer;

	// toolbar.dat ̕ۑ
	CListCtrl* pList2 = (CListCtrl*)GetDlgItem(IDC_LIST2);
	if ( pList2->GetItemCount() > 0 ) {
		//+++ CStdioFile fin( strOptionPath +  _T("\\toolbar.dat")	, CFile::modeCreate | CFile::modeWrite );
		CWriteTextFile fin( strOptionPath +  _T("\\toolbar.dat")  , CFile::modeCreate | CFile::modeWrite );

		for ( int i = 0 ; i < pList2->GetItemCount() ; i++ ) {
			fin.WriteString( ItoStr( int( pList2->GetItemData( i )) ) +  _T("\n") );
		}
		fin.Close();
	}
	CPropertyPage::OnOK();
}


void CPageToolbar::OnButton1()
{ // ǉ
	int index1 = GetListIndex(&m_List1);
	int index2 = GetListIndex(&m_List2);

	if (index1 == -1) { // IĂȂ
		return;
	}

	int nNewIndex = ( index2 > -1 ) ? index2 : m_List2.GetItemCount();

	// ACe擾
	LVITEM item;
	item.iItem = index1;

	GetListItemStruct(&m_List1, &item);

	item.iItem = nNewIndex;

	m_List2.InsertItem( &item );

	delete[] item.pszText;
}

void CPageToolbar::OnButton2()
{ // 폜
	m_List2.DeleteItem(GetListIndex(&m_List2));
}

void CPageToolbar::OnButton3()
{ // 
	int index = GetListIndex(&m_List2);
	if (index == 0)
		return;

	// ACe擾
	LVITEM item;
	item.iItem = index;

	GetListItemStruct(&m_List2, &item);

	item.iItem = index - 1;

	// ւ
	m_List2.DeleteItem(index);
	m_List2.InsertItem( &item );
	// tH[JX𓖂Ă
	m_List2.SetItemState(index - 1, 2, LVIS_SELECTED);
	//
	delete[] item.pszText;
}

void CPageToolbar::OnButton4()
{ // 
	int index = GetListIndex(&m_List2);
	if (index == m_List2.GetItemCount() - 1) {
		return;
	}
	// ACe擾
	LVITEM item;
	item.iItem = index + 1;

	GetListItemStruct( &m_List2, &item );

	item.iItem = index;

	// ւ
	m_List2.DeleteItem( index+1 );
	m_List2.InsertItem( &item );
	// tH[JX𓖂Ă
	m_List2.SetItemState(index+1 , 2 , LVIS_SELECTED);
	//
	delete[] item.pszText;
}

int CPageToolbar::GetListIndex(CListCtrl* pListWnd)
{ // I𒆂̃ACe
	POSITION pos = pListWnd->GetFirstSelectedItemPosition();
	return pListWnd->GetNextSelectedItem(pos);
}

int CPageToolbar::GetListItemStruct( CListCtrl* pListWnd , LVITEM* pItem )
{ // \̂擾 pszText K free 邱
	TCHAR* pszText		= new TCHAR[MAX_PATH];

	pItem->iSubItem 	= 0;
	pItem->mask 		= LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
	pItem->pszText		= pszText;
	pItem->cchTextMax	= MAX_PATH;

	pListWnd->GetItem(pItem);
	return true;
}


BOOL CPageToolbar::OnSetActive()
{
	CPropertySheet* pDlg = static_cast<CPropertySheet*>(GetParent());
	if ( pDlg->GetPageCount() > 1 ) {
		CPageToolbarEdit* pPageEdit = static_cast<CPageToolbarEdit*>( pDlg->GetActivePage() );
		if ( pPageEdit ) {
			pPageEdit->SaveToolbar();
		}
	}
	LoadToolbar();
	return CPropertyPage::OnSetActive();
}
