#if !defined(PATRIOT_CLASS_FILTERSCOLLECTION)
#define PATRIOT_CLASS_FILTERSCOLLECTION

#include "stdafx.h"
#include "patriotGlobal2.h"

#define WEB_FILTER_MAX_COUNT 64

struct WebFilter{
	WebFilter() {	//+++ Ô߂̏ǉ.
		bImage	  = bBgm	= bVideo	 = bScript	= bJava 	 = bActiveX =
		bActiveX2 = bSilent = bShiftLock = bTabLock = bAntiPopup = bCookie	= bCookie2 = 0;
	}
public:
	CString 		strUrl;
	CString 		strProxy;

	//+++ 0,1,2̒lƂ̂ŁA߂Č^intɏC. (O͕u).
	int /*BOOL*/	bImage;
	int /*BOOL*/	bBgm;
	int /*BOOL*/	bVideo;

	int /*BOOL*/	bScript;
	int /*BOOL*/	bJava;
	int /*BOOL*/	bActiveX;
	int /*BOOL*/	bActiveX2;

	int /*BOOL*/	bSilent;
	int /*BOOL*/	bShiftLock;
	int /*BOOL*/	bTabLock;
	int /*BOOL*/	bAntiPopup;

	int 			bCookie;
	int 			bCookie2;
};

class CFiltersCollection{
public:
	WebFilter*	pWebFilter;
	long		count;

	/// 
	CFiltersCollection(){
		count = 0;
		pWebFilter = new WebFilter[WEB_FILTER_MAX_COUNT];
	}

	/// j
	~CFiltersCollection(){
		delete[] pWebFilter;
	}

	/// ǉ
	bool Add(WebFilter GetFilter, int index)
	{
		for (int i = count; i > index; i--) {
			pWebFilter[i] = pWebFilter[i-1];
		}
		pWebFilter[index] = GetFilter;
		AddCount();
		return true;
	}

	/// 폜
	bool Delete(int index)
	{
		for (int i = index; i < count; i++) {
			pWebFilter[i] = pWebFilter[i + 1];
		}
		count--;
		return true;
	}

	/// Ĕzu
	bool AddCount()
	{
		count++;

		if (count % WEB_FILTER_MAX_COUNT == 0) {
			WebFilter* pOldFilter	= pWebFilter;
			pWebFilter				= new WebFilter[count + WEB_FILTER_MAX_COUNT];
			for (int i = 0; i < count; i++) {
				pWebFilter[i] = pOldFilter[i];
			}
			delete[] pOldFilter;
		}
		return true;
	}

	// f[^̃[h
	bool LoadData(CString strFileName)
	{
		TRY{
			//+++ CStdioFile fin( strFileName, CFile::modeRead);
			CReadTextFile fin( strFileName, CFile::modeRead);
			CString str;
			count = 0;

			while (fin.ReadString(pWebFilter[count].strUrl)) {
				fin.ReadString(pWebFilter[count].strProxy);
				fin.ReadString(str);

				pWebFilter[count].bImage		= str.GetAt( 0)=='1' ? 1 :(str.GetAt( 0) == '2' ? 2 : 0 );
				pWebFilter[count].bBgm			= str.GetAt( 1)=='1' ? 1 :(str.GetAt( 1) == '2' ? 2 : 0 );
				pWebFilter[count].bVideo		= str.GetAt( 2)=='1' ? 1 :(str.GetAt( 2) == '2' ? 2 : 0 );
				pWebFilter[count].bScript		= str.GetAt( 3)=='1' ? 1 :(str.GetAt( 3) == '2' ? 2 : 0 );
				pWebFilter[count].bJava 		= str.GetAt( 4)=='1' ? 1 :(str.GetAt( 4) == '2' ? 2 : 0 );
				pWebFilter[count].bActiveX		= str.GetAt( 5)=='1' ? 1 :(str.GetAt( 5) == '2' ? 2 : 0 );
				pWebFilter[count].bActiveX2 	= str.GetAt( 6)=='1' ? 1 :(str.GetAt( 6) == '2' ? 2 : 0 );
				pWebFilter[count].bSilent		= str.GetAt( 7)=='1' ? 1 :(str.GetAt( 7) == '2' ? 2 : 0 );
				pWebFilter[count].bShiftLock	= str.GetAt( 8)=='1' ? 1 :(str.GetAt( 8) == '2' ? 2 : 0 );
				pWebFilter[count].bTabLock		= str.GetAt( 9)=='1' ? 1 :(str.GetAt( 9) == '2' ? 2 : 0 );
				pWebFilter[count].bAntiPopup	= str.GetAt(10)=='1' ? 1 :(str.GetAt(10) == '2' ? 2 : 0 );
				pWebFilter[count].bCookie		= str.GetAt(11)=='1' ? 1 :(str.GetAt(11) == '2' ? 2 : 0 );
				pWebFilter[count].bCookie2		= str.GetAt(12)=='1' ? 1 :(str.GetAt(12) == '2' ? 2 : 0 );
				fin.ReadString(str);
				AddCount();
			}
			fin.Close();
		}
		CATCH( CFileException, e ){
			if ( e->m_cause != CFileException::fileNotFound) {
				TRACE( _T("File could not be opened %d \n"), e->m_cause);
			}
		}END_CATCH
		return true;
	}

	/// tB^ۑ
	bool SaveData( CString strFileName )
	{
		CString strFlag;
		//+++ CStdioFile fin( strFileName, CFile::modeCreate | CFile::modeWrite);
		CWriteTextFile fin( strFileName, CFile::modeCreate | CFile::modeWrite);
		for (int i = 0; i < count; i++) {
			fin.WriteString(pWebFilter[i].strUrl   + _T("\n") );
			fin.WriteString(pWebFilter[i].strProxy + _T("\n") );

			strFlag = GetStringFromFilter(pWebFilter[i]);
			fin.WriteString(strFlag + _T("\n") );
			fin.WriteString( _T("\n") );
		}
		fin.Close();
		return true;
	}

	/// tB^ۑ
	CString GetStringFromFilter(WebFilter filter)
	{
		CString str;
		str  =(TCHAR)('0' + filter.bImage);
		str +=(TCHAR)('0' + filter.bBgm);
		str +=(TCHAR)('0' + filter.bVideo);
		str +=(TCHAR)('0' + filter.bScript);
		str +=(TCHAR)('0' + filter.bJava);
		str +=(TCHAR)('0' + filter.bActiveX);
		str +=(TCHAR)('0' + filter.bActiveX2);
		str +=(TCHAR)('0' + filter.bSilent);
		str +=(TCHAR)('0' + filter.bShiftLock);
		str +=(TCHAR)('0' + filter.bTabLock);
		str +=(TCHAR)('0' + filter.bAntiPopup);
		str +=(TCHAR)('0' + filter.bCookie);
		str +=(TCHAR)('0' + filter.bCookie2);
		return str;
	}
protected:

};

#endif
