#if !defined(AFX_EXTENTIONPAGEEDIT_H__1BEB4CAF_F7BF_4A0E_B883_753FEE7D73A5__INCLUDED_)
#define AFX_EXTENTIONPAGEEDIT_H__1BEB4CAF_F7BF_4A0E_B883_753FEE7D73A5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ExtensionPageEdit.h : wb_[ t@C
//
#include "DragTreeCtrl.h"
#include <vector>
/////////////////////////////////////////////////////////////////////////////
// CExtensionPageEdit _CAO

class CExtensionPageEdit : public CPropertyPage
{
	DECLARE_DYNCREATE(CExtensionPageEdit)

	typedef std::vector<CString> CStringVector;
// RXgNV
public:
	CExtensionPageEdit();
	~CExtensionPageEdit();

	HWND			m_hFrameWnd;
	CImageList		m_ImageList;
	CString 		m_strAppPath;
	CUIntArray		m_arrExtensionOption;
	CUIntArray		m_arrExtensionAccel;
// _CAO f[^
	//{{AFX_DATA(CExtensionPageEdit)
	enum { IDD = IDD_EXTPAGE_EDIT };
	CDragTreeCtrl	m_Tree;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(CExtensionPageEdit)
	public:
	virtual void OnOK();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V

public:
	BOOL AppendItem(const CString& strItem);
	BOOL ConfigItem(const CString& strItem);
private:
	/// g@\̖O
	void EnumExtensionNames(const CString& strFileName, CStringVector& strItemNames, CStringVector& strRegisteredItemNames);
	/// j[ɓo^ς݂̊g
	void EnumTreeItems(const CTreeCtrl* pTreeWnd, std::vector<CString>& strItemNames);

protected:
	BOOL ItemIsGroup(HTREEITEM item);
	BOOL DeleteItem(HTREEITEM item);
	CString OutputNode(HTREEITEM itemParent, int iTabIndent);
	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CExtensionPageEdit)
	virtual BOOL OnInitDialog();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndlabeleditTree1(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_EXTENTIONPAGEEDIT_H__1BEB4CAF_F7BF_4A0E_B883_753FEE7D73A5__INCLUDED_)
