// ExtensionPageInstall.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "ExtensionPageInstall.h"
#include "EditExtensionDlg.h"
#include "../InputBox.h"
#include "../InputBox.cpp"

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
*/

/////////////////////////////////////////////////////////////////////////////
// CExtensionPageInstall vpeB y[W

IMPLEMENT_DYNCREATE(CExtensionPageInstall, CPropertyPage)

CExtensionPageInstall::CExtensionPageInstall()
	: CPropertyPage(CExtensionPageInstall::IDD)
	, m_hFrameWnd(0)
	, m_strAppPath()
	, m_arrExtensionName()
{
	//{{AFX_DATA_INIT(CExtensionPageInstall)
		//  - ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
}

CExtensionPageInstall::~CExtensionPageInstall()
{
}

void CExtensionPageInstall::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExtensionPageInstall)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExtensionPageInstall, CPropertyPage)
	//{{AFX_MSG_MAP(CExtensionPageInstall)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExtensionPageInstall bZ[W nh
void CExtensionPageInstall::LoadIni()
{ // ini[h
	// CXg[ς݊gꗗ
//	CListBox* pList1 = (CListBox*)GetDlgItem(IDC_LIST1);
//	pList1->ResetContent();
	m_arrExtensionName.RemoveAll();

	TCHAR chrBuf[1024*32];
	LPTSTR pChr = chrBuf;

	::GetPrivateProfileSectionNames(chrBuf, 1024 * 32, m_strAppPath+ _T("\\extension\\default.ini") );
	while (*pChr != '\0'){
		m_arrExtensionName.Add(pChr);
		// pList1->AddString(pChr);
		pChr += lstrlen(pChr) + 1;
	}

	pChr = chrBuf;
	::GetPrivateProfileSectionNames(chrBuf, 1024 * 32, m_strAppPath+ _T("\\extension\\user.ini") );
	while (*pChr != '\0'){
		m_arrExtensionName.Add(pChr);
		// pList1->AddString(pChr);
		pChr += lstrlen(pChr) + 1;
	}
	ReloadList();
}

void CExtensionPageInstall::ReloadList()
{ // XgXV
	CEdit* pEdit1 = static_cast<CEdit*>( GetDlgItem(IDC_EDIT1) );
	CString strInput;
	pEdit1->GetWindowText(strInput);
	strInput.MakeLower();

	CListBox* pList1 = (CListBox*)GetDlgItem(IDC_LIST1);
	pList1->ResetContent();

	for (int i = 0; i < m_arrExtensionName.GetSize() ; i++) {
		CString strList = m_arrExtensionName.GetAt(i);
		strList.MakeLower();
		if ( strInput.IsEmpty() || strList.Find( strInput ) > -1 ) {
			pList1->AddString( m_arrExtensionName.GetAt(i) );
		}
	}
	if (pList1->GetCount()>0)
		pList1->SetCurSel(0);
}

BOOL CExtensionPageInstall::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// bura.exêtH_
	TCHAR lpszAppPath[MAX_PATH];
	lstrcpyn( lpszAppPath, AfxGetApp()->m_pszHelpFilePath, MAX_PATH );
	*_tcsrchr( lpszAppPath, _T('\\') ) = NULL;
	m_strAppPath = lpszAppPath;

	LoadIni();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CExtensionPageInstall::OnButton1()
{ // CXg[
	CRect rect;
	GetDlgItem(IDC_BUTTON1)->GetWindowRect(&rect);
	CMenu menu;menu.CreatePopupMenu();
	menu.AppendMenu( MF_STRING, ID_EXTENSION_EXTENSION + 0, _T("ubN}[Nbg̒ǉ(&B)") );
	menu.AppendMenu( MF_STRING, ID_EXTENSION_EXTENSION + 1, _T("vOC̒ǉ(&F)") );
	menu.AppendMenu( MF_STRING, ID_EXTENSION_EXTENSION + 2, _T("XNvg̒ǉ(&S)") );
	// \
	UINT nID = TrackPopupMenu(menu.m_hMenu,
						TPM_LEFTALIGN /*| TPM_RIGHTBUTTON*/ | TPM_RETURNCMD,
						rect.left, rect.bottom, 0, m_hWnd, NULL );
	menu.DestroyMenu();

	if (nID == 0) {
		return;
	}

	CString strTitle;
	CString strIniSession;
	switch (nID - ID_EXTENSION_EXTENSION) {
	case 0://ubN}[Nbg
		InstallFile(_T(""));
		break;
	case 1://vOC
		{
			// t@C擾
			CFileDialog dlg( TRUE, NULL, m_strAppPath + _T("\\extension\\."), OFN_FILEMUSTEXIST | OFN_ENABLESIZING | OFN_EXPLORER, _T("Dynamic Link Library(*.dll)|*.dll|ׂẴt@C|*.*") );
			if (dlg.DoModal() == IDOK) {
				InstallFile(dlg.GetPathName());
			}
		}
		break;
	default://XNvg
		{
			// t@C擾
			CFileDialog dlg(TRUE, NULL, m_strAppPath + _T("\\extension\\."), OFN_FILEMUSTEXIST | OFN_ENABLESIZING | OFN_EXPLORER, _T("Java XNvg(*.js)|*.js|ׂẴt@C|*.*") );
			if (dlg.DoModal() == IDOK) {
				InstallFile(dlg.GetPathName());
			}
		}
		break;
	}
}

void CExtensionPageInstall::OnButton2()
{ // ACXg[
	// I𒆂̍ږ擾
	CListBox* pList1 = (CListBox*)GetDlgItem(IDC_LIST1);
	int iIndex = pList1->GetCurSel();
	if (iIndex == -1 || iIndex>=pList1->GetCount()) {
		return;
	}
	CString strSession;
	pList1->GetText(iIndex , strSession);
	strSession= _T("[") + strSession + _T("]");

	if (AfxMessageBox( strSession + _T("폜܂B\n̋@\j[ɓo^ĂȂƂmFĂB")	, MB_OKCANCEL | MB_ICONINFORMATION) == IDCANCEL) {
		return;
	}

	pList1->DeleteString(iIndex);

	CString str, strBuf;
	BOOL bDelete = FALSE;
	// user.ini
	//+++ CStdioFile sf1r( m_strAppPath + _T("\\extension\\user.ini" )	, CFile::modeRead);
	CReadTextFile sf1r( m_strAppPath + _T("\\extension\\user.ini" )  , CFile::modeRead);
	while (sf1r.ReadString(str)) {
		if (str == strSession) { // 폜ZNV
			bDelete = TRUE;
			do{ // ǂݔ΂
				if (!sf1r.ReadString(str)) {
					str= _T("");
					break;
				}
			}while(str.GetAt(0)!='[');
		}
		strBuf += str + _T("\n");
	}
	sf1r.Close();

	//+++ CStdioFile sf1w(m_strAppPath+ _T("\\extension\\user.ini")  , CFile::modeCreate | CFile::modeWrite);
	CWriteTextFile sf1w(m_strAppPath+ _T("\\extension\\user.ini")  , CFile::modeCreate | CFile::modeWrite);
	sf1w.WriteString(strBuf);
	sf1w.Close();

	if (bDelete)
		return;

	// default.ini
	//+++ CStdioFile sf2r(m_strAppPath+ _T("\\extension\\default.ini")	, CFile::modeRead);
	CReadTextFile sf2r(m_strAppPath+ _T("\\extension\\default.ini")  , CFile::modeRead);
	while (sf2r.ReadString(str)) {
		if (str == strSession) { // 폜ZNV
			do{ // ǂݔ΂
				if (!sf2r.ReadString(str)) {
					str= _T("");
					break;
				}
			}while(str.GetAt(0)!='[');
		}
		strBuf += str + _T("\n");
	}
	sf2r.Close();

	//+++ CStdioFile sf2w(m_strAppPath+ _T("\\extension\\default.ini"), CFile::modeCreate | CFile::modeWrite);
	CWriteTextFile sf2w(m_strAppPath+ _T("\\extension\\default.ini"), CFile::modeCreate | CFile::modeWrite);
	sf2w.WriteString(strBuf);
	sf2w.Close();
}

void CExtensionPageInstall::OnChangeEdit1()
{
	ReloadList();
}

void CExtensionPageInstall::OnButton3()
{ // ݒ
	// I𒆂̍ږ擾
	CListBox* pList1 = (CListBox*)GetDlgItem(IDC_LIST1);
	int nIndex = pList1->GetCurSel();
	if (nIndex == -1 || nIndex >= pList1->GetCount()) {
		return;
	}
	CString strExtensionName;
	pList1->GetText(nIndex, strExtensionName);

	CString strIniPath = m_strAppPath + _T("\\extension\\user.ini");

	int mode = GetPrivateProfileInt(strExtensionName, _T("mode"), -1, strIniPath);
	if (mode == -1) {
		strIniPath = m_strAppPath+ _T("\\extension\\default.ini");
		mode = GetPrivateProfileInt(strExtensionName, _T("mode"), -1, strIniPath);
	}
	if (mode == 0){ // javascript(bookmarklet)
		TCHAR chrBuf[MAX_PATH*8];
		GetPrivateProfileString( strExtensionName, _T("url"), _T(""), chrBuf, MAX_PATH * 8, strIniPath);
		CString strURL = chrBuf;

		CInputBox dlg;
		strURL = dlg.GetInput( _T("ubN}[Nbg̕ҏW"), _T("u") + strExtensionName + _T("v̐Ve͂ĂB"), strURL );
		if ( !strURL.IsEmpty() ) {
			::WritePrivateProfileString(strExtensionName, _T("url"), strURL, m_strAppPath + _T("\\extension\\user.ini") );
		}
	} else if (mode == 1) { // DLL
		TCHAR chrBuf[MAX_PATH];
		GetPrivateProfileString(strExtensionName, _T("dll"), _T(""), chrBuf, MAX_PATH, strIniPath);
		CString strDll = chrBuf;
		GetPrivateProfileString(strExtensionName, _T("func"), _T(""), chrBuf, MAX_PATH, strIniPath);
		CString strFunc = chrBuf;
//		GetPrivateProfileString(strExtensionName, _T("param") , "" , chrBuf , MAX_PATH , strIniPath);
//		CString strParam = chrBuf;

//		LPDISPATCH pDisp;
//		if (m_Tabs.count>0)
//			pDisp = ((CPatriotView*)m_Tabs.pView[m_wndTabBar.GetCurSel()])->GetWebBrowserApp();
//		else
//			pDisp = NULL;

		int nResult = 0;
		HMODULE hMod = (HMODULE)AfxLoadLibrary(m_strAppPath + _T("\\extension\\") + strDll);
		if (hMod){
			typedef BOOL (WINAPI EXECPLUGIN)(HWND, LPCTSTR);
			EXECPLUGIN* lpfnExecPlugin = (EXECPLUGIN*)GetProcAddress(hMod, "ShowConfig" );
			if (lpfnExecPlugin) {
				nResult = lpfnExecPlugin(m_hFrameWnd , strFunc);
				if (nResult == 0) {
					AfxMessageBox( _T("ShowConfig̎sɃG[܂B") );
				}
			} else {
				AfxMessageBox( _T("ShowConfig̎擾Ɏs܂B") );
			}
			AfxFreeLibrary(hMod);
		} else {
			AfxMessageBox(strDll+ _T("̓ǂݍ݂Ɏs܂B") );
		}
	} else if (mode == 2) { // Oscript
		TCHAR chrBuf[MAX_PATH*8];
		GetPrivateProfileString(strExtensionName, _T("src"), NULL, chrBuf, MAX_PATH*8, strIniPath);
		CString strEditor = _T("notepad.exe");
		ShellExecute(m_hWnd, _T("open"), strEditor, _T("\"") + m_strAppPath + _T("\\extension\\") + chrBuf + _T("\""), 0, SW_SHOW);
	}
}


/// gt@CCXg[
BOOL CExtensionPageInstall::InstallFile(LPCTSTR lpszPluginFile)
{
	m_strAppPath = g_Options.strAppPath;

	CString strTitle;
	CString strIniSession;

	if (_tcsstr(lpszPluginFile, _T(".dll"))) {
		//vOC
		CString strFileName = lpszPluginFile;
		if (strFileName.Find(m_strAppPath + _T("\\extension")) == -1) {
			// extensiontH_złȂ
			AfxMessageBox( _T("ǂݍ݃G[F") + strFileName + _T("\nextensiontH_ȉDLLIĂB") );
			return FALSE;
		}
		// vOCN
		TCHAR chrProfile[256 * 32] = _T("");
		int nResult = 0;

		HMODULE hMod = (HMODULE)AfxLoadLibrary(strFileName);
		if (hMod){
			typedef BOOL (WINAPI EXECPLUGIN)(HWND, LPTSTR, int);
			EXECPLUGIN* lpfnExecPlugin = (EXECPLUGIN*)GetProcAddress(hMod, "GetProfile" );
			if (lpfnExecPlugin){
				nResult = lpfnExecPlugin(m_hFrameWnd, chrProfile, 256*32);
				if (nResult) { // 
					strIniSession = chrProfile;
				} else {
					AfxMessageBox( _T("GetProfile̎sɃG[܂B") );
					return FALSE;
				}
			} else {
				AfxMessageBox( _T("GetProfile̎擾Ɏs܂B") );
				return FALSE;
			}
			AfxFreeLibrary(hMod);
		}
		else{
			AfxMessageBox(strFileName + _T("̓ǂݍ݂Ɏs܂B"));
			return FALSE;
		}
	} else if (_tcsstr(lpszPluginFile, _T(".js"))) {
		//XNvg
		CString strFile = lpszPluginFile;
		CString strAbout;

		int nFind = strFile.ReverseFind(_T('\\'));
		if (nFind < 0) {
			AfxMessageBox(_T("t@C܂B\n") + strFile);
			return FALSE;
		}
		const int EXT_LENGTH = 3;
		strTitle = strFile.Mid(nFind + 1, strFile.GetLength() - nFind - EXT_LENGTH - 1);

		CString strExtFolder = m_strAppPath + _T("\\extension");
		if (strFile.Find(strExtFolder) == -1) {
			// extensiontH_złȂ
			AfxMessageBox( _T("ǂݍ݃G[F") + strFile + _T("extension tH_ȉ̃t@CIĂB") );
			return FALSE;
		}
		// Greasemonkey
		if (strTitle.Find(_T(".user")) > 0) {
			strTitle = strTitle.Left(strTitle.GetLength() - 5);

			//+++ CStdioFile fileScript(strFile, CFile::modeRead);
			CReadTextFile fileScript(strFile, CFile::modeRead);
			CString str;
			while(fileScript.ReadString(str) && str.Find(_T("// ==UserScript==")) != 0) {
			}
			while (fileScript.ReadString(str) && str.Find(_T("// ==/UserScript==")) != 0) {
				if (str.Find(_T("// @name")) == 0 && str.Find(_T("@namespace")) != 0) {
					strTitle = str.Mid(8);
					strTitle.TrimLeft();
				}
				else if (str.Find(_T("// @description")) == 0) {
					strAbout = str.Mid(15);
					strAbout.TrimLeft();
				}
				else if (str.Find(_T("// @include")) == 0) {
					CString strInclude = str.Mid(11);
					strInclude.TrimLeft();

					if (AfxMessageBox( _T("̃XNvgɂ͎ŝ߂̏񂪊܂܂Ă܂B\ñTCgł̃XNvgIɎs悤ɃtB^ݒ肵܂H\n") + strInclude , MB_YESNO | MB_ICONQUESTION ) == IDNO) {
						continue;
					}
					// tB^ɒǉ
					//+++ CStdioFile fileFilter(g_Options.strOptionPath + _T("\\filter.dat"), CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite);
					//+++ fileFilter.SeekToEnd();
					CWriteTextFile fileFilter(g_Options.strOptionPath + _T("\\filter.dat"), CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite, 1/*t@CǋL*/);
					fileFilter.WriteString( strInclude + _T("\nextension:[") + strTitle + _T("]\n2222222222222\n\n"));
					fileFilter.Close();
				}
			}
			fileScript.Close();
		}
		strFile = strFile.Mid(strExtFolder.GetLength() + 1);

		strIniSession = _T("[") + strTitle + _T("]\n")
			+ _T("mode=2\n")
			+ _T("src=") + strFile + _T("\n");
		if (!strAbout.IsEmpty()) {
			strIniSession += _T("about=") + strAbout + _T("\n");
		}
	} else {
		//ubN}[Nbg
		CInputBox dlg;
		strTitle = dlg.GetInput( _T("ubN}[Nbg̒ǉ"), _T("ubN}[Nbgɕt^Cg͂ĂB"), _T("") );
		if (!strTitle.IsEmpty()) {
			CString strUrl = dlg.GetInput( _T("ubN}[Nbg̒ǉ"), _T("u") + strTitle + _T("v̓e͂ĂB"), _T("") );
			if (!strUrl.IsEmpty()) {
				strTitle.Replace(_T('['), _T('_'));
				strTitle.Replace(_T(']'), _T('_'));
				strIniSession = _T("[") + strTitle + _T("]\n")
					+ _T("mode=0\n")
					+ _T("url=") + strUrl + _T("\n");
			}
		}
	}

	int nFind = strIniSession.Find( _T('['), 0 );
	int nLength = strIniSession.GetLength();
	while (nFind != -1 && nFind < nLength) {
		int nFindEnd = strIniSession.Find( _T(']'), nFind );

		strTitle = strIniSession.Mid(nFind + 1, nFindEnd - nFind - 1);

		BOOL bExitInDefaultIni = (::GetPrivateProfileInt( strTitle, _T("mode"), -1, m_strAppPath + _T("\\extension\\default.ini")) != -1);
		BOOL bExitInUserIni    = (::GetPrivateProfileInt( strTitle, _T("mode"), -1, m_strAppPath + _T("\\extension\\user.ini"))    != -1);

		if (bExitInDefaultIni || bExitInUserIni) {
			// ㏑CXg[
			if (AfxMessageBox( strTitle + _T(" ͊ɃCXg[Ă܂B\n݂̐ݒɏ㏑܂H"), MB_YESNO | MB_ICONQUESTION ) == IDNO) {
				nFind = strIniSession.Find( _T('['), nFindEnd );
				if (nFind == -1) {
					nFind = nLength;
				}
				continue;
			}
			if (bExitInDefaultIni) {
				::WritePrivateProfileSection( strTitle, _T("\0\0"), m_strAppPath + _T("\\extension\\default.ini"));

				CString strBuffer;
				CString str;
				//+++ CStdioFile fileIn( m_strAppPath + _T("\\extension\\default.ini"), CFile::modeRead );
				CReadTextFile fileIn( m_strAppPath + _T("\\extension\\default.ini"), CFile::modeRead );
				while (fileIn.ReadString(str)) {
					if (str.CompareNoCase( _T('[') + strTitle + _T(']') ) != 0) {
						strBuffer += str + _T('\n');
					}
				}
				fileIn.Close();

				//+++ CStdioFile fileOut( m_strAppPath + _T("\\extension\\default.ini"), CFile::modeCreate | CFile::modeWrite );
				CWriteTextFile fileOut( m_strAppPath + _T("\\extension\\default.ini"), CFile::modeCreate | CFile::modeWrite );
				fileOut.WriteString(strBuffer);
				fileOut.Close();
			}
			if (bExitInUserIni) {
				::WritePrivateProfileSection( strTitle, _T("\0\0"), m_strAppPath + _T("\\extension\\user.ini"));

				CString strBuffer;
				CString str;
				//+++ CStdioFile fileIn( m_strAppPath + _T("\\extension\\user.ini"), CFile::modeRead );
				CReadTextFile fileIn( m_strAppPath + _T("\\extension\\user.ini"), CFile::modeRead );
				while (fileIn.ReadString(str)) {
					if (str.CompareNoCase( _T('[') + strTitle + _T(']') ) != 0) {
						strBuffer += str + _T('\n');
					}
				}
				fileIn.Close();

				//+++ CStdioFile fileOut( m_strAppPath + _T("\\extension\\user.ini"), CFile::modeCreate | CFile::modeWrite );
				CWriteTextFile fileOut( m_strAppPath + _T("\\extension\\user.ini"), CFile::modeCreate | CFile::modeWrite );
				fileOut.WriteString(strBuffer);
				fileOut.Close();
			}
		}

		// ZbVt@Cɏ
		nFindEnd = strIniSession.Find( _T('['), nFindEnd );
		if (nFindEnd == -1) {
			nFindEnd = nLength;
		}
		CString strSession = strIniSession.Mid(nFind, nFindEnd - nFind);

		// t@Cɏ	//+++ :t@CǋL.
		//+++ CStdioFile file( m_strAppPath + _T("\\extension\\user.ini"), CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite );
		//+++ file.SeekToEnd();
		CWriteTextFile file( m_strAppPath + _T("\\extension\\user.ini"), CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite, 1/*t@CǋL*/ );
		file.WriteString(strSession);
		if (strSession.Right(1) != _T("\n")) {
			file.WriteString(_T("\n"));
		}
		file.Close();

		if (!bExitInDefaultIni & !bExitInUserIni) {
			if (AfxMessageBox(strTitle + _T(" ̃CXg[܂B\n̋@\j[ɒǉ܂H"), MB_YESNO | MB_ICONINFORMATION) == IDYES) {
				// j[ɒǉ
				CEditExtensionDlg* pDlg = static_cast<CEditExtensionDlg*>(GetParent());
				if (pDlg && pDlg->pageEdit.m_arrExtensionOption.GetSize() > 0) {
					pDlg->pageEdit.AppendItem(strTitle);
				}
			}
		}
		nFind = nFindEnd;
	}
	LoadIni();
	return TRUE;
}
